PROGRAM dibujo;


CONST

    {Minimo y maximo del alto y ancho del triangulo. Por como esta hecho el
    algoritmo, ANCHO_MIN y ALTO_MIN nunca deberian ser menores que 3 y 2,
    respectivamente}
    ANCHO_MAX = 80;
    ANCHO_MIN = 3;
    ALTO_MAX = 24;
    ALTO_MIN = 2;

    {Por si queremos cambiar los caracteres que dibujan el triangulo}
    PUNTO = '*';
    HUECO = ' ';

    {Estas constantes siempre han de estar en mayusculas, ya que cuando el
    usuario introduce su respuesta, esta se pasa a mayusculas. Esto sirve para
    aceptar la respuesta tanto si se escribe en mayusculas como en minusculas}
    TECLA_REPETIR = 'S';
    TECLA_NO_REPETIR = 'N';
    TECLA_RELLENO = 'L';
    TECLA_NO_RELLENO = 'H';


VAR

    {Variables para la lectura de opciones}
    repetir : char;
    rellenar : char;

    {Ancho y alto del triangulo}
    ancho : integer;
    alto : integer;

    {Variables necesarias para el algoritmo de dibujo}
    espaciosMasPorLinea : real; {Espacios que hay que anadir cada linea a los
    que ya habia (con decimales)}
    espaciosAcumulados : real; {Espacios teoricos (con decimales) que habria que
    poner para conseguir una hipotenusa perfecta. Como esto es imposible,
    utilizaremos la siguiente variable}
    espaciosAponer : integer; {Espacios que se ponen en la linea actual, antes
    de la hipotenusa}
    i : integer; {Variables indice de los bucles FOR}
    j : integer;

{Comienzo del programa principal}
BEGIN

    REPEAT

        {Mostramos un titulo}
        writeln;
        writeln ('DIBUJAR UN TRIANGULO RECTANGULO');
        writeln ('-------------------------------');
        writeln;

        {Pedimos la anchura del triangulo}
        REPEAT
            write ('Introduzca la anchura (minimo ', ANCHO_MIN, ', maximo ',
                ANCHO_MAX, '): ');
            {Usamos directivas del compilador, como pedia el enunciado}
            {$I-}
            readln (ancho);
            {$I+}
            IF ((ioresult <> 0) OR (ancho < ANCHO_MIN) OR (ancho > ANCHO_MAX)) THEN
                writeln ('Opcion incorrecta, intente de nuevo');
        UNTIL ((ancho >= ANCHO_MIN) AND (ancho <= ANCHO_MAX));

        {Pedimos la altura del triangulo, del mismo modo que la anchura}
        REPEAT
            write ('Introduzca la altura (minimo ', ALTO_MIN, ', maximo ',
                ALTO_MAX, '): ');
            {$I-}
            readln (alto);
            {$I+}
            IF ((ioresult <> 0) OR (alto < ALTO_MIN) OR (alto > ALTO_MAX)) THEN
                writeln ('Opcion incorrecta, intente de nuevo');
        UNTIL ((alto >= ALTO_MIN) AND (alto <= ALTO_MAX));

        {Preguntamos si se desea el triangulo relleno o no, del mismo modo que
        la anchura y la altura}
        REPEAT
            write ('Introduzca si desea el triangulo relleno o hueco (',
                TECLA_RELLENO, '/', TECLA_NO_RELLENO, '): ');
            {$I-}
            readln (rellenar);
            {$I+}
            rellenar := upcase (rellenar);
            IF ((ioresult <> 0) OR ((rellenar <> TECLA_RELLENO) AND (rellenar <> TECLA_NO_RELLENO))) THEN
                writeln ('Opcion incorrecta, intente de nuevo');
        UNTIL ((rellenar = TECLA_RELLENO) OR (rellenar = TECLA_NO_RELLENO));
        writeln;

        {Calculamos los espacios que hay que annadir, se explica en el LEEME,
        empieza con 0 espacios acumulados}
        espaciosMasPorLinea := (ancho - 1) / (alto - 1);
        espaciosAcumulados := 0;

        {Escribimos cada linea: Este FOR va de la linea 1 a la ultima}
        FOR i := 1 TO alto DO
        BEGIN
            {A los espacios teoricos les quitamos los decimales}
            espaciosAponer := trunc (espaciosAcumulados);

            {Esto es para que no cierre el triangulo en la penultima linea, por
            los errores de redondeo de numeros reales en binario}
            IF ((i = alto - 1) AND (espaciosAponer = ancho - 1)) THEN
                dec (espaciosAponer);

            {Escribimos los espacios que haya antes de la hipotenusa}
            FOR j := 1 TO espaciosAponer DO
                write (HUECO);

            {Escribimos un punto para empezar el triangulo en esa linea. Solo un
            punto, porque puede ser que el resto este hueco}
            write (PUNTO);

            {Si es la primera linea o se quiere el triangulo relleno, la linea
            se rellena de puntos, si no, se llena de huecos para tener el
            triangulo hueco. Calculamos los puntos a escribir como el ancho del
            triangulo menos los espacios que ya hemos puesto, menos 2 (punto de
            apertura y punto de cierre del triangulo, en cada linea)}
            IF ((rellenar = TECLA_RELLENO) OR (i = 1)) THEN
                FOR j := 1 TO (ancho - espaciosAponer - 2) DO
                    write (PUNTO)
            ELSE
                FOR j := 1 TO (ancho - espaciosAponer - 2) DO
                    write (HUECO);

            {Se cierra el triangulo en esa linea con un punto, a no ser que sea
            la ultima ya}
            IF (i < alto) THEN
                writeln (PUNTO)
            ELSE
                writeln;

            {Acumulamos espacios para la siguiente pasada del for. Si estamos en
            la penultima linea, nos aseguramos de que aunque haya errores de
            redondeo, el triangulo se cerrara correctamente en la esquina
            inferior derecha}
            espaciosAcumulados := espaciosAcumulados + espaciosMasPorLinea;
            espaciosAponer := trunc (espaciosAcumulados);
            IF ((i = alto - 1) AND (espaciosAponer = ancho - 2)) THEN
                espaciosAcumulados := espaciosAcumulados + 1; {No se puede usar
                inc, porque espaciosAcumulados es real}
        END;
             
        writeln;

        {Preguntamos si se desea dibujar otro triangulo, del mismo modo que las
        anteriores entradas de datos}
        REPEAT
            write ('Quiere dibujar otro triangulo? (', TECLA_REPETIR, '/',
                TECLA_NO_REPETIR, '): ');
            {$I-}
            readln (repetir);
            {SI+}
            repetir := upcase (repetir);
            IF ((ioresult <> 0) OR ((repetir <> TECLA_REPETIR) AND (repetir <> TECLA_NO_REPETIR))) THEN
                writeln ('Opcion incorrecta, intente de nuevo');
        UNTIL ((repetir = TECLA_REPETIR) OR (repetir = TECLA_NO_REPETIR));

    {Cuando no se quiera repetir, finaliza el programa}
    UNTIL (repetir = TECLA_NO_REPETIR);

END. {Fin del programa}
